<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head><title>Tabelle</title>

<!-- Formatierungsangaben, knnen beliebig gendert werden. -->
<style type="text/css">
body
{
background-color:#ffffff;
font-size:100.01%;
font-family:arial,helvetica,sans;
}

pre
{
font-size:1.2em;
}

table
{
background-color:#999999;
border:1px solid #000000;
}

tr,td
{
margin:0em;
padding:0.4em;
border:1px solid #000000;
}

th.headline
{
text-align:center;
background-color:#444444;
color:#ffffff;
font-weight:800;
font-size:1.5em;
padding-bottom:0.1em;
padding-top:0.1em;
}
</style>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>

<?php
function tabelle($dir="",$link="",$head="")
{
// Konfiguration ab hier:
// ---------------------------------------------

// Die Daten, die in der Tabelle angezeigt werden sollen. 
// Je nachdem, welche Art von Tabelle Sie zeigen mchten, mssen Sie hier 
// die geeignete "Vorarbeit" leisten. Wenn Sie eine Tabelle mit Downloads
// erzeugen mchten, dann mu diese Liste hier eine Liste aus den Dateien
// sein, die Sie zum Download anbieten. Wenn Sie eine "normale" Tabelle mit
// Texten als Inhalt darstellen, dann mu die Liste die Textelemente enthalten.
// Das hier ist z.B. eine Liste mit Downloads:
// $dateien=array("handbuch.pdf","beispiele.pdf","rechnung.xls","aufgabenblatt.xls","kommentare.odt");

// Das hier wrde z.B. eine Text-Tabelle ergeben:
// $dateien=array("Dieser Text hier steht in der ersten Zelle","Und dieser hier in der zweiten","Die Dritte ist auch nicht leer","","Die vierte schon, die fnfte aber nicht mehr");
// Sie haben zwei Mglichkeiten, die Daten fr die Tabelle anzugeben: 
// Entweder Sie definieren hier eine Liste mit Ihren Daten:
$dateien=array("Das hier ist Zelle eins","das hier die zweite","drei","vier","fnf","sechs","sieben","acht","neun","zehn"); 

// Oder alle in diesem Verzeichnis vorhandenen Dateien nehmen (z.B. Bilder).
// Diese Variante ist insbesondere fr groe Tabellen mit Downloads 
// oder Bildern geeignet.
// (Falls dieses Verzeichnis existiert, hat es Vorrang vor der Liste oben!)
// Es werden alle Dateien aus dem Verzeichnis gelesen. Unterverzeichnisse
// werden hier zwar gelesen, aber nicht ausgewertet. Sprich: Diese Version
// des Tabellengenerators kann mit Unterverzeichnissen nichts anfangen! 
// Deshalb bitte keine Verzeichnisbume anlegen, sondern nur dieses eine
// Verzeichnis mit Dateien fllen. Das Verzeichnis mu auf derselben Ebene
// liegen wie diese Datei ("table.php").
// Name des Verzeichnisses:
$verzeichnis="meine_bilder";



// Sollen die Dateien verlinkt werden, und wenn ja, wie?
// bild = Die Dateien werden als Bild angezeigt (geht logischerweise nur
//        bei Bilddateien). Die Bilder werden in dieser Version 1:1 abgebildet,
//	  also nicht skaliert! Bei groen Abmessungen vielleicht etwas
//	  ungnstig.
//
// link = Die Dateien werden als Downloads angezeigt, die Dateigre wird
//	  mit angegeben.
//
// text = Die Daten werden als Text gewertet und in der Tabelle dargestellt.
//	  Bei einer Dateiliste werden die Dateinamen angezeigt.
//
// Links funktionieren logischerweise nur dann, wenn auch Dateien zum 
// verlinken da sind, sprich: Es exisitert ein Verzeichnis mit Dateien, oder
// Sie haben in der manuellen Datenliste eine Liste mit Dateien angegeben.
$linktyp="bild";


// Wie breit soll die Tabelle werden? Hier die Anzahl der Spalten angeben,
// die Zeilenzahl ermittelt sich dann automatisch aus der Gesamtmenge der
// darzustellenden Daten bzw. Dateien.
// So viele Spalten soll die Tabelle bekommen:
$spalten=3; 


// Bei sehr langen Tabellen (=vielen Daten) wird die Tabelle leicht
// unbersichtlich. Deshalb wird jeder zweite Zeile eine andere Hintergrund-
// farbe zugewiesen. Wenn nicht gewnscht, einfach zwei Mal dieselbe Farbe
// eintragen. 
// Die Farbe bitte im Hex-Format angeben (#rrggbb), z.B. #ff0000 --> rot.
// Abwechselnde Hintergrundfarben der Tabellenzeilen:
$background_odd="#eeeeee";
$background_even="#dddddd";

// Hier kann man der Tabelle einen Kopf verpassen, sozusagen eine Art
// Tabellenberschrift innerhalb der Tabelle. Wenn nicht gewnscht,
// einfach leer lassen bzw. die Zeile da unten auskommentieren.
$headline="Eine berschrift";

// Einen Teil dieser Parameter knnen Sie der Funktion auch direkt bergeben,
// das ist z.B. dann sinnvoll, wenn Sie mehrere Verzeichnisse mit z.B. Bildern
// und Downloads haben (z.B. urlaub_06, urlaub_07 und so weiter). 
// Sie knnen dann die Funktion "tabelle" mit bis zu drei Parametern aufrufen.
// Der erste Parameter gibt das Verzeichnis an, aus dem die Dateien stammen,
// der zweite die Art, wie sie dargestellt werden sollen (Links, Bilder oder 
// Text), der dritte eine berschrift fr die Tabelle.
//
// Beispiel: 
// echo tabelle("meine_bilder","bild","Meine Bildersammlung");
// Das wrde eine Tabelle mit Bildern aus dem Verzeichnis "meine_bilder"
// darstellen, die berschrift wre "Meine Bildersammlung".
// ---------------------------------------------
// Ende der Konfiguration
// Ab hier braucht nichts mehr gendert zu werden
$html="";
if(!empty($dir)) $verzeichnis=$dir;
if(!empty($link)) $linktyp=$link;
if(!empty($head)) $headline=$head;
//if (!empty($verzeichnis)) if(is_dir($verzeichnis)) $dateien=array_splice(scandir($verzeichnis),2);
if (!empty($verzeichnis)) if(is_dir($verzeichnis)) $dateien=dircontent($verzeichnis);
$anzahl=count($dateien);
if (!empty($anzahl)) $html="<table>";
else return("Nullinger");
if(!empty($headline)) $html.="<tr><th class=\"headline\" colspan=\"$spalten\">$headline</th></tr>";
for($x=1;$x<=$anzahl;$x++)
 {
 if($x%$spalten==1) 
  {
   if($x%2==0) $html.="<tr style=\"background-color:$background_even;\">";
   else $html.="<tr style=\"background-color:$background_odd;\">";
  }
 if((($x==$anzahl)&&($anzahl%$spalten)!=0))
  {
  $html.="<td colspan=\"";
  $html.=$spalten-($anzahl%$spalten)+1;
  $html.="\">";
  switch($linktyp)
  {
  case "bild": $html.=makeimagetag($verzeichnis,$dateien[$x-1]);break;
  case "link": $html.=makelink($verzeichnis,$dateien[$x-1]);break;
  default: $html.=$dateien[$x-1];
  }  
  $html.="</td>";
  }
 else 
  {
  $html.="<td>";
  switch($linktyp)
  {
  case "bild": $html.=makeimagetag($verzeichnis,$dateien[$x-1]);break;
  case "link": $html.=makelink($verzeichnis,$dateien[$x-1]);break;
  default: $html.=$dateien[$x-1];
  }  
  //echo $dateien[$x-1];
  $html.="</td>\n";
  }
 if($x%$spalten==0) $html.="</tr>\n";
}
$html.="</table>";
return $html;
}

function makeimagetag($path,$datei)
{
$out="";
$current=$path."/".$datei;
$size=getimagesize($current);
$out="<img src=\"".$current."\" width=\"".$size[0]."\" height=\"".$size[1]."\" alt=\"\">";
return $out;
}

function makelink($path,$datei)
{
$out="";
$current=$path."/".$datei;
$size=filesize($current);
if($size<1024) $fs=$size." Byte";
elseif(($size>=1024)&&($size<1024*1024)) $fs=round($size/1024)." KB";
else $fs=round($size/(1024*1024),2)." MB";
$out="<a href=\"".$current."\">".$datei." (".$fs.")</a>";
return $out;
}

function dircontent($path)
{
if($dir=opendir($path))
{
 while($file=readdir($dir))
 {
 if (!is_dir($file) && $file != "." && $file != "..")
 {
 $files[]=$file;
 }
}
closedir($dir);
}
return $files;
}


?>


<!-- 
Hier beginnt der normale HTML-Inhalt der Seite. Zwei Tabellen sind
fr Demo-Zwecke hier mit eingebunden.
-->


<h1>Demo-Seite f&uuml;r den Tabellen-Generator</h1>
Der Tabellen-Generator erzeugt aus Daten oder Verzeichnisinhalten HTML-Tabellen. Diese Tabellen knnen in bereits bestehende Seiten eingebunden werden.<br>
Hier sehen Sie zwei Beispiele:
<h2>Hier steht normaler HTML-Inhalt</h2>
<p>
Z.B. Bahnhof. Und so wird die Tabelle eingefgt - hier mit Bildern. Die Bilder<br>werden nach dem Dateinamen alphabetisch sortiert:<br>
1. <strong>D</strong>rei.gif - 2. <strong>E</strong>ins.gif, 3. <strong>F</strong>uenf.gif und so weiter:
</p>

<?php
echo tabelle();
?>
<br>
Diese Tabelle ist so eingef&uuml;gt worden:<br>
<pre>
echo tabelle();
</pre>
<p>Die Ausgabe, d.h., da&szlig; die Tabelle Bilder zeigen soll und welche, ist<br>
innerhalb dieser PHP-Datei konfiguriert worden.</p>

<p>
Man kann die Tabelle auch ber Parameter steuern und die Funktion mit<br>
verschiedenen Verzeichnissen innerhalb einer Seite mehrmals nutzen:
</p>
<?php
echo tabelle("meine_downloads","link","Meine Downloads");
?>
<br>
Eingef&uuml;gt wurde diese Tabelle mit einer Zeile in PHP:<br>
<pre>
echo tabelle("meine_downloads","link","Meine Downloads");
</pre>
<p>
Diesmal ist die Tabellenausgabe &uuml;ber die drei Parameter konfiguriert worden. Wie das geht steht in der Datei.<br>
Nat&uuml;rlich kann man die Tabelle selbst auch nach belieben formatieren. Das <br>
funktioniert &uuml;ber css-Angaben innerhalb der PHP-Datei.
</p>
&larr; <a href="../../index.php">zur&uuml;ck zum Index</a>
</body>
</html>


